unit ugraftool;
interface

USES Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
     Dialogs, StdCtrls, Buttons, ComCtrls;
TYPE Matrix        = ARRAY[1..1000] OF TPOINT;
     PointType3D   = RECORD
                      x,y,z : INTEGER;
                     END;
     Matrix3D      = ARRAY[1..1000] OF PointType3D;

PROCEDURE Signet_Daten(VAR Figur: Matrix);
procedure Pause(ms: Cardinal);
PROCEDURE Verschieben(x,y,Anzahl:INTEGER; VAR Figur:Matrix);
PROCEDURE Verzerren(x,y:REAL; Anzahl:INTEGER; VAR Figur:Matrix);
PROCEDURE Mittelpunkt(Radius,Winkel:INTEGER; VAR XM,YM:INTEGER);
PROCEDURE Drehen(X_Dreh,Y_Dreh,Drehwinkel:INTEGER; VAR Figur: Matrix; Anzahl:INTEGER);
PROCEDURE Horiz_Spiegeln(Anzahl: INTEGER; VAR Figur: Matrix);
PROCEDURE Transforme_R3_R2(Anzahl: INTEGER; a:Matrix3D; VAR Figur:Matrix);
PROCEDURE Drehen3D(DZ:PointType3D; x,y,z: INTEGER; VAR P:PointType3D);
{Dreht einen Punkt P um ein Drehzentrum DZ um einen bestimmten Winkel x,y,z im Gradma
um die x,y,z - Achsen, und liefert die neuen Koordinaten von P zurck.}

implementation
PROCEDURE Signet_Daten(VAR Figur: Matrix);
VAR i : INTEGER;
BEGIN
  {Polygon}  Figur[1].X:=  0;    Figur[1].Y:=-100;
             Figur[2].X:= 75;    Figur[2].Y:=-75;
             Figur[3].X:=100;    Figur[3].Y:=  0;
             Figur[4].X:= 75;    Figur[4].Y:= 75;
             Figur[5].X:=  0;    Figur[5].Y:=100;
             Figur[6].X:=-75;    Figur[6].Y:= 75;
             Figur[7].X:=-100;   Figur[7].Y:=  0;
             Figur[8].X:=-75;    Figur[8].Y:=-75;
             Figur[9].X:=  0;    Figur[9].Y:=100;
 {PC}
 { Bildschirm }
  Figur[10].X:=-30;    Figur[10].Y:=-50;
  Figur[11].X:= 30;    Figur[11].Y:=-50;
  Figur[12].X:= 30;    Figur[12].Y:= -2;
  Figur[13].X:=-30;    Figur[13].Y:= -2;

  Figur[14].X:=-24;    Figur[14].Y:=-44;
  Figur[15].X:= 24;    Figur[15].Y:=-44;
  Figur[16].X:= 24;    Figur[16].Y:= -8;
  Figur[17].X:=-24;    Figur[17].Y:= -8;
  { Bildschirmmittelpunkt }
  Figur[18].X:= 0;     Figur[18].Y:=-25;
  { Computer }
  Figur[19].X:=-60;   Figur[19].Y:= 2;
  Figur[20].X:= 60;   Figur[20].Y:=  2;
  Figur[21].X:= 60;   Figur[21].Y:= 40;
  Figur[22].X:=-60;   Figur[22].Y:= 40;
  { Laufwerke }
  Figur[23].X:= 20;    Figur[23].Y:= 10;
  Figur[24].X:= 50;    Figur[24].Y:= 10;
  Figur[25].X:= 20;    Figur[25].Y:= 20;
  Figur[26].X:= 50;    Figur[26].Y:= 20;
  { Schrift }
  { P }
  Figur[27].X:=-40;    Figur[27].Y:=-60;
  Figur[28].X:=-36;    Figur[28].Y:=-80;
  Figur[29].X:=-24;    Figur[29].Y:=-80;
  Figur[30].X:=-26;    Figur[30].Y:=-70;
  Figur[31].X:=-38;    Figur[31].Y:=-70;
  { R }
  Figur[32].X:=-20;    Figur[32].Y:=-60;
  Figur[33].X:=-16;    Figur[33].Y:=-80;
  Figur[34].X:=- 4;    Figur[34].Y:=-80;
  Figur[35].X:= -6;    Figur[35].Y:=-70;
  Figur[36].X:=-18;    Figur[36].Y:=-70;
  Figur[37].X:=-10;    Figur[37].Y:=-60;
  { O }
  Figur[38].X:= 0;     Figur[38].Y:=-60;
  Figur[39].X:= 4;     Figur[39].Y:=-80;
  Figur[40].X:=16;     Figur[40].Y:=-80;
  Figur[41].X:=12;     Figur[41].Y:=-60;
  Figur[42].X:= 0;     Figur[42].Y:=-60;
  { F }
  Figur[43].X:= 20;    Figur[43].Y:=-60;
  Figur[44].X:= 22;    Figur[44].Y:=-70;
  Figur[45].X:= 30;    Figur[45].Y:=-70;
  Figur[46].X:= 22;    Figur[46].Y:=-70;
  Figur[47].X:= 24;    Figur[47].Y:=-80;
  Figur[48].X:= 36;    Figur[48].Y:=-80;
  { I }
  Figur[49].X:= 40;    Figur[49].Y:=-60;
  Figur[50].X:= 44;    Figur[50].Y:=-80;
  { S }
  Figur[51].X:=-40;    Figur[51].Y:= 70;
  Figur[52].X:=-28;    Figur[52].Y:= 70;
  Figur[53].X:=-26;    Figur[53].Y:= 60;
  Figur[54].X:=-38;    Figur[54].Y:= 60;
  Figur[55].X:=-36;    Figur[55].Y:= 50;
  Figur[56].X:=-24;    Figur[56].Y:= 50;
  { OF }
  FOR I:=57 TO 67 DO BEGIN
                     Figur[I].X:= Figur[I-19].X-20;
                     Figur[I].Y:= Figur[I-19].Y+130
                     END;
  { T }
  Figur[68].X:= 26;    Figur[68].Y:= 70;
  Figur[69].X:= 30;    Figur[69].Y:= 50;
  Figur[70].X:= 24;    Figur[70].Y:= 50;
  Figur[71].X:= 36;    Figur[71].Y:= 50;

END;

procedure Pause(ms: Cardinal); // (c) 2002, Michael Winter
  var
   Stop: Cardinal;
   Timer: Cardinal;
  begin
   Timer := SetTimer(0, 0, ms, nil);
   Stop := GetTickCount + ms;
   repeat
     Application.HandleMessage;
   until Application.Terminated or (Integer(GetTickCount - Stop) >= 0);
   KillTimer(0, Timer);
  end;

PROCEDURE Verschieben(x,y,Anzahl: INTEGER; VAR Figur: Matrix);
VAR I: INTEGER;
BEGIN
  FOR I:= 1 TO Anzahl DO
      BEGIN
        Figur[I].X:= Figur[I].X + x;
        Figur[I].Y:= Figur[I].Y + y;
      END
END;

PROCEDURE Verzerren(x,y: REAL; Anzahl: INTEGER; VAR Figur: Matrix);
VAR I: INTEGER;
BEGIN
  FOR I:= 1 TO Anzahl DO
      BEGIN
        Figur[I].X:= ROUND(Figur[I].X * x);
        Figur[I].Y:= ROUND(Figur[I].Y * y)
      END
END;

PROCEDURE Mittelpunkt(Radius,Winkel: INTEGER; VAR XM,YM: INTEGER);
VAR Bogen: REAL;
BEGIN
   Bogen:= Winkel*PI/180;
   XM:= ROUND(Radius*COS(Bogen));
   YM:= ROUND(Radius*SIN(Bogen));
END;

PROCEDURE Drehen(X_Dreh,Y_Dreh,Drehwinkel: INTEGER; VAR Figur: Matrix; Anzahl: INTEGER);
VAR Bogen,X0,Y0: REAL;
    I          : WORD;
BEGIN
  Bogen:= Drehwinkel*PI/180;
  FOR I:=1 TO Anzahl DO
      BEGIN
        X0:= COS(Bogen)*(Figur[I].X-X_Dreh)
            -SIN(Bogen)*(Figur[I].Y-Y_Dreh) + X_Dreh;
        Y0:= SIN(Bogen)*(Figur[I].X-X_Dreh)
            +COS(Bogen)*(Figur[I].Y-Y_Dreh) + Y_Dreh;
        Figur[I].X:= ROUND(X0);
        Figur[I].Y:= ROUND(Y0)
      END
END;

PROCEDURE Horiz_Spiegeln(Anzahl: INTEGER; VAR Figur: Matrix);
VAR I: INTEGER;
BEGIN
  FOR I:= 1 TO Anzahl DO
      BEGIN
        Figur[I].X:= -Figur[I].X;
        Figur[I].Y:= Figur[I].Y;
      END
END;

PROCEDURE Transforme_R3_R2(Anzahl: INTEGER; a:Matrix3D; VAR Figur:Matrix);
VAR i : INTEGER;
BEGIN
 For i:=1 TO Anzahl DO
   BEGIN
    Figur[i].x:=TRUNC(a[i].y-a[i].x/2);
    Figur[i].y:=-TRUNC(a[i].z-a[i].x/2);
   END;
END;

PROCEDURE Drehen3D(DZ:PointType3D; x,y,z: INTEGER; VAR P:PointType3D);
VAR P1: PointType3D;
    ax,ay,az : REAL;
BEGIN
 ax:=(x*Pi)/180; ay:=(y*Pi)/180; az:=(z*Pi)/180;

 P1.x:=P.x;
 P1.y:=ROUND((P.y-DZ.y)*cos(ax) - (P.z-DZ.z)*sin(ax) + DZ.y);
 P1.z:=ROUND((P.y-DZ.y)*sin(ax) + (P.z-DZ.z)*cos(ax) + DZ.z);
 P:=P1;

 P1.y:=P.y;
 P1.x:=ROUND((P.x-DZ.x)*cos(ay) - (P.z-DZ.z)*sin(ay) + DZ.x);
 P1.z:=ROUND((P.x-DZ.x)*sin(ay) + (P.z-DZ.z)*cos(ay) + DZ.z);
 P:=P1;

 P1.z:=P.z;
 P1.x:=ROUND((P.x-DZ.x)*cos(az) - (P.y-DZ.y)*sin(az) + DZ.x);
 P1.y:=ROUND((P.x-DZ.x)*sin(az) + (P.y-DZ.y)*cos(az) + DZ.y);
 P:=P1;
END;

end.
